unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, MSHTML, ActiveX, AppEvnts, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    ApplicationEvents1: TApplicationEvents;
    PopupMenu1: TPopupMenu;
    Demo1: TMenuItem;
    Demo2: TMenuItem;
    PopupMenu2: TPopupMenu;
    Copy1: TMenuItem;
    SelectAll1: TMenuItem;
    procedure WebBrowser1BeforeNavigate2(Sender: TObject; const pDisp: IDispatch;
      var URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
      var Cancel: WordBool);
    procedure WebBrowser1StatusTextChange(Sender: TObject; const Text: WideString);
    procedure ApplicationEvents1Message(var Msg: tagMSG;
      var Handled: Boolean);
    procedure Copy1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Demo1Click(Sender: TObject);
    procedure Demo2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure InitHtml(AWebBrower: TWebBrowser);
    procedure ShowHtml(content: string);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  crlf = #13#10;
  HTML_Head = //Header ҳҳü
    '<html>' + crlf +
    '<head>' + crlf +
    '<title>HTML Application - Author:Zhong Wan</title>' + crlf +
    '</head>' + crlf +
    '<body>' + crlf +
    '<table width="100%">' + crlf +
    '  <tr>' + crlf +
    '    <td>Header</td>' + crlf +
    '    <td align="right"><a href="Home">Home</a></td>' + crlf +
    '    <td align="right"><a href="Help">Help</a></td>' + crlf +
    '  </tr>' + crlf +
    '</table>' + crlf +
    '<hr>';
  HTML_Foot = //Footer ҳҳ
    '<hr>' + crlf +
    '<table width="100%">' + crlf +
    '  <tr>' + crlf +
    '    <td>Footer</td>' + crlf +
    '    <td align="right"><a href="Author">Author:Zhong Wan</a></td>' + crlf +
    '    <td align="right"><a href="http://www.2ccc.com" target="_blank">http://www.2ccc.com</a></td>' + crlf +
    '    <td align="right">4/15/2004</td>' + crlf +
    '  </tr>' + crlf +
    '</table>' + crlf +
    '<table width="100%">' + crlf +
    '  <tr>' + crlf +
    '    <td align="center"><a href="Close">Close This HTML Form</a></td>' + crlf +
    '  </tr>' + crlf +
    '</table>' + crlf +
    '</body>' + crlf +
    '</html>';
  HTML_Home = //Home Page ҳҳ
    '<table width="100%">' + crlf +
    '  <tr>' + crlf +
    '    <td><a href="HomeContent">Home Content</a></td>' + crlf +
    '  </tr>' + crlf +
    '</table>';
  HTML_Help = //Help Page ҳ
    '<table width="100%">' + crlf +
    '  <tr>' + crlf +
    '    <td><a href="HelpContent">Help Content</a></td>' + crlf +
    '  </tr>' + crlf +
    '</table>';

implementation

{$R *.dfm}

procedure TForm1.InitHtml(AWebBrower: TWebBrowser);
var
  URL: OleVariant;
begin
  //Init IE ʼIEؼ
  URL := 'about:blank';
  AWebBrower.Navigate2(URL);
end;

procedure TForm1.ShowHtml(content: string);
var
  v: Variant;
  HTMLDocument: IHTMLDocument2;
begin
  //Write HTML to IE дHTML뵽IEؼ
  v := VarArrayCreate([0, 0], varVariant);
  v[0] := content;
  HTMLDocument := WebBrowser1.Document as IHTMLDocument2;
  HTMLDocument.write(PSafeArray(TVarData(v).VArray));
  HTMLDocument.close;
  HTMLDocument := nil;
end;

procedure TForm1.WebBrowser1BeforeNavigate2(Sender: TObject; const pDisp: IDispatch;
  var URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
  var Cancel: WordBool);
const
  hUrl = 'about:blank';
begin
  //Capture Link from IE IEнػHTMLؼӦ¼
  if string(URL) = hUrl + 'Close' then
  begin
    Close;
  end;
  if string(URL) = hUrl + 'Home' then
  begin
    ShowHtml(HTML_Head + HTML_Home + HTML_Foot);
    Cancel := True; //don't change page
    Exit;
  end;
  if string(URL) = hUrl + 'Help' then
  begin
    ShowHtml(HTML_Head + HTML_Help + HTML_Foot);
    Cancel := True;
    Exit;
  end;
  if string(URL) = hUrl + 'Author' then
  begin
    ShowMessage('Author:Zhong Wan');
    Cancel := True;
    Exit;
  end;
  if string(URL) = hUrl + 'HomeContent' then
  begin
    PopupMenu1.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
    Cancel := True;
    Exit;
  end;
  if string(URL) = hUrl + 'HelpContent' then
  begin
    ShowMessage('Help Content Clicked');
    Cancel := True;
    Exit;
  end;
end;

procedure TForm1.WebBrowser1StatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  Caption := Text;
end;

procedure TForm1.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
const
  KeyPressMask = $80000000;
begin
  //Set Keys ÿݼ
  Handled := False;
  //Pop Menu IEؼϵ˵
  if IsChild(WebBrowser1.Handle, Msg.Hwnd) and (Msg.Message = WM_RBUTTONUP) then
  begin
    PopupMenu2.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
    Handled := True;
  end;
  if (Msg.message = WM_KEYDOWN) and ((Msg.lParam and KeyPressMask) = 0) and (GetKeyState(VK_CONTROL) < 0) and (Msg.wParam = Ord('N')) then
  begin
    //Disable Ctrl+N
    Handled := True;
  end;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
  //Copy 
  try
    WebBrowser1.ExecWB(OLECMDID_COPY, OLECMDEXECOPT_PROMPTUSER);
  except
  end;
end;

procedure TForm1.SelectAll1Click(Sender: TObject);
begin
  //Select All ȫѡ
  try
    WebBrowser1.ExecWB(OLECMDID_SELECTALL, OLECMDEXECOPT_PROMPTUSER);
  except
  end;
end;

procedure TForm1.PopupMenu2Popup(Sender: TObject);
begin
  //Edit Menu ༭˵
  if WebBrowser1.OleObject.Document.queryCommandEnabled('Copy') then
    Copy1.Enabled := True
  else
    Copy1.Enabled := False;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitHtml(WebBrowser1);
end;

procedure TForm1.Demo1Click(Sender: TObject);
begin
  showmessage('Demo');
end;

procedure TForm1.Demo2Click(Sender: TObject);
begin
  showmessage('Demo2');
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ShowHtml(HTML_Head + HTML_Home + HTML_Foot);
end;

initialization
  OleInitialize(nil);

finalization
  OleUninitialize;

end.

